//!APP-HOOK: pre-build

log("Convertion started");

Promise.all(
    dirRec(path.join("kraken", "Themes"))
    .filter( fileName => /\.png$/i.test(fileName) )
    .map( imageName => readImage(imageName)
                        .then(imageData => saveImage(imageName.replace(/\.png/i, ".565"), imageData))
    )
).then(_=>{
    log("Convertion finished");
    if(hookTrigger == "pre-build") hookArgs[1]();
}).catch(_=>{
    if(hookTrigger == "pre-build") hookArgs[1]("Conversion error");
});

function dirRec(name){
    let out = [];
    dir(name).forEach(child=>{
        const fullChild = path.join(name, child);
        out = out.concat(stat(fullChild).isDirectory() ? dirRec(fullChild) : [fullChild]);
    });
    return out;
}

function saveImage(name, image){
    const out = [];
    const w = image.width;
    const h = image.height;
    const buf = image.data;

    for( let i=0; i<buf.length; i++ ){
        let r = buf[i++];
        let g = buf[i++];
        let b = buf[i++];
        r = (r/255.0)*0x1F<<11;
        g = (g/255.0)*0x3F<<5;
        b = (b/255.0)*0x1F;
        let c = r|g|b;
        out.push( c&0xFF );
        out.push( c>>>8 );
    }
    
    write(name, new Uint8Array(out), undefined);
    return true;
}